hdu 1695 GCD(欧拉函数+容斥原理)

http://acm.hdu.edu.cn/showproblem.php?

pid=1695

非常经典的题。同一时候感觉也非常难。

在区间[a,b]和[c,d]内分别随意取出一个数x,y,使得gcd(x,y) = k。问这种(x,y)有多少对。能够觉得a,c均为1,并且gcd(5,7)与gcd(7,5)是同一种。

由于gcd(x,y) = k,那么gcd(x/k,y/k) = 1。也就是求区间[1,b/k]和[1,d/k]内这种(x,y)对使得gcd(x,y) = 1。

为了防止计数反复,首先假定b/k <= d/k,那么当y <= b/k时。这种对数有Euler[y]个。当y > b/k时,先把y进行素因子分解为p1,p2...pi。仅仅要可以求出[1,b/k]内与y不互质的数,那么与y互质的数用b减去就行了。求与y不互质的数的个数用到容斥原理。由于某些素因子的倍数是一样的,令pi的整数倍集合为Ai,那么就是求这些集合的并。

求集合的并依据容斥关系进行dfs。

这个想了好久没有想出来,參考了某大神的博客写出来的。大体思路就是如果素因子分解出来是p1,p2,p3,先把仅仅有p1倍数的个数求出来。这是一个递归的过程。即是p1倍数的个数减去p1p2倍数的个数减去p1p2p3倍数的个数,相同的对于p2,p2倍数的个数减去p2p3倍数的个数。

#include <stdio.h>
#include <iostream>
#include <map>
#include <set>
#include <list>
#include <stack>
#include <vector>
#include <math.h>
#include <string.h>
#include <queue>
#include <string>
#include <stdlib.h>
#include <algorithm>
//#define LL long long
#define LL __int64
#define eps 1e-12
#define PI acos(-1.0)
#define C 240
#define S 20
using namespace std;
const int maxn = 100010;

int flag[maxn];
int prime[maxn];
int phi[maxn];
vector <int> edge[maxn];
int test,a,b,c,d,k;

//基于素数筛的欧拉函数
void init()
{
    memset(flag,0,sizeof(flag));
    prime[0] = 0;
    phi[1] = 1;
    for(int i = 2; i < maxn; i++)
    {
        if(flag[i] == 0)
        {
            prime[++prime[0]] = i;
            phi[i] = i-1;
        }
        for(int j = 1; j <= prime[0] && prime[j]*i < maxn; j++)
        {
            flag[prime[j]*i] = 1;
            if(i % prime[j] == 0)
                phi[prime[j]*i] = phi[i]*prime[j];
            else phi[prime[j]*i] = phi[i]*(prime[j]-1);
        }
    }
}

//vector存每一个数的素因子。
void spilt()
{
    for(int i = 1; i < maxn; i++)
    {
        int tmp = i;
        for(int j = 1; prime[j]*prime[j] <= tmp; j++)
        {
            if(tmp % prime[j] == 0)
            {
                edge[i].push_back(prime[j]);
                while(tmp % prime[j] == 0)
                    tmp /= prime[j];

            }
            if(tmp == 1)
                break;
        }
        if(tmp > 1)
            edge[i].push_back(tmp);
    }
}

//求小于等于b的与cur不互质的数的个数
LL dfs(int st, int b, int cur)
{
    LL res = 0;
    for(int i = st; i < (int)edge[cur].size(); i++)
    {
        int k = b/edge[cur][i];
        res += k - dfs(i+1,k,cur);
    }
    return res;
}

int main()
{
    init();
    spilt();

    scanf("%d",&test);
    for(int item = 1; item <= test; item++)
    {
        scanf("%d %d %d %d %d",&a,&b,&c,&d,&k);
        if(k == 0 || k > b || k > d)
        {
            printf("Case %d: 0\n",item);
            continue;
        }
        b /= k;
        d /= k;
        if(b > d)
            swap(b,d);
        LL ans = 0;
        for(int i = 1; i <= b; i++)
        {
            ans += phi[i];
        }
        for(int i = b+1; i <= d; i++)
        {
            ans += b-dfs(0,b,i);
        }
        printf("Case %d: %I64d\n",item,ans);

    }
    return 0;
}

时间: 2024-10-12 08:34:46

hdu 1695 GCD(欧拉函数+容斥原理)的相关文章

HDU 1695 GCD 欧拉函数+容斥原理+质因数分解

链接:http://acm.hdu.edu.cn/showproblem.php?pid=1695 题意:在[a,b]中的x,在[c,d]中的y,求x与y的最大公约数为k的组合有多少.(a=1, a <= b <= 100000, c=1, c <= d <= 100000, 0 <= k <= 100000) 思路:因为x与y的最大公约数为k,所以xx=x/k与yy=y/k一定互质.要从a/k和b/k之中选择互质的数,枚举1~b/k,当选择的yy小于等于a/k时,可以

HDU 1695 GCD 欧拉函数+容斥定理

输入a b c d k求有多少对x y 使得x在a-b区间 y在c-d区间 gcd(x, y) = k 此外a和c一定是1 由于gcd(x, y) == k 将b和d都除以k 题目转化为1到b/k 和1到d/k 2个区间 如果第一个区间小于第二个区间 讲第二个区间分成2部分来做1-b/k 和 b/k+1-d/k 第一部分对于每一个数i 和他互质的数就是这个数的欧拉函数值 全部数的欧拉函数的和就是答案 第二部分能够用全部数减去不互质的数 对于一个数i 分解因子和他不互质的数包括他的若干个因子 这个

hdu 1695 GCD 欧拉函数+容斥

题意:给定a,b,c,d,k x属于[1 , c],y属于[1 , d],求满足gcd(x,y)=k的对数.其中<x,y>和<y,x>算相同. 思路:不妨设c<d,x<=y.问题可以转化为x属于[1,c / k ],y属于[1,d/k ],x和y互质的对数. 那么假如y<=c/k,那么对数就是y从1到c/k欧拉函数的和.如果y>c/k,就只能从[ c/k+1 , d ]枚举,然后利用容斥.详见代码: /****************************

hdu 1695 GCD 欧拉函数 + 容斥

http://acm.hdu.edu.cn/showproblem.php?pid=1695 要求[L1, R1]和[L2, R2]中GCD是K的个数.那么只需要求[L1, R1 / K]  和 [L2, R2 / K]中GCD是1的对数. 由于(1, 2)和(2, 1)是同一对. 那么我们枚举大区间,限制数字一定是小于等于枚举的那个数字就行. 比如[1, 3]和[1, 5] 我们枚举大区间,[1, 5],在[1, 3]中找互质的时候,由于又需要要小于枚举数字,那么直接上phi 对于其他的,比如

HDU 2588 GCD (欧拉函数)

GCD Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 1013    Accepted Submission(s): 457 Problem Description The greatest common divisor GCD(a,b) of two positive integers a and b,sometimes writt

HDU 1695 GCD(欧拉函数+容斥原理)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1695 题意:x位于区间[a, b],y位于区间[c, d],求满足GCD(x, y) = k的(x, y)有多少组,不考虑顺序. 思路:a = c = 1简化了问题,原问题可以转化为在[1, b/k]和[1, d/k]这两个区间各取一个数,组成的数对是互质的数量,不考虑顺序.我们让d > b,我们枚举区间[1, d/k]的数i作为二元组的第二位,因为不考虑顺序我们考虑第一位的值时,只用考虑小于i的情

hdu 1695 GCD【欧拉函数+容斥原理】

GCD Time Limit: 6000/3000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 6253    Accepted Submission(s): 2291 Problem Description Given 5 integers: a, b, c, d, k, you're to find x in a...b, y in c...d that GCD(x, y

hdu (欧拉函数+容斥原理) GCD

题目链接http://acm.hdu.edu.cn/showproblem.php?pid=1695 看了别人的方法才会做 参考博客http://blog.csdn.net/shiren_Bod/article/details/5787722 题意 a,b,c,d,k五个数,a与c可看做恒为1,求在a到b中选一个数x,c到d中选一个数y,使得gcd(x,y)等于k,求x和y有多少对. 首先可以想到选取的必是k的倍数,假设是x和y倍,则x和y一定是互质的在,那么就变成了求1到b/k和1到d/k的之

GuGuFishtion HDU - 6390 (欧拉函数,容斥)

GuGuFishtion \[ Time Limit: 1500 ms\quad Memory Limit: 65536 kB \] 题意 给出定义\(Gu(a, b) = \frac{\phi(ab)}{\phi(a)\phi(b)}\) 求出\(\sum_{a=1}^{m}\sum_{b=1}^{n}Gu(a,b) (mod p)\) 思路 首先对于欧拉函数,我们知道欧拉函数的朴素式子为:\(\phi(n) = n*(1-\frac{1}{p1})*(1-\frac{1}{p2}) * ..